## libpoly-0.1.11.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#
# Stop warning on cygwin
#
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

project(libpoly C CXX)

option(LIBPOLY_BUILD_PYTHON_API "Build the Python API" ON)
option(LIBPOLY_BUILD_STATIC_PIC "Build the static PIC library" ON)
option(LIBPOLY_BUILD_STATIC "Build the static library" ON)
option(LIBPOLY_BUILD_STATISTICS "Build the statistics internals" OFF)

set(LIBPOLY_VERSION_MAJOR 0)
set(LIBPOLY_VERSION_MINOR 1)
set(LIBPOLY_VERSION_PATCH 11)
set(LIBPOLY_VERSION ${LIBPOLY_VERSION_MAJOR}.${LIBPOLY_VERSION_MINOR}.${LIBPOLY_VERSION_PATCH})

if(APPLE)
 # This is the simplest setting that seems to currently work on the mac.
 #
 set(CMAKE_MACOSX_RPATH OFF)
 set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
endif()

#
# Search for GMP. We do this here since GMP_INCLUDE_DIR may be
# required for building the python binding.
#
# Find the GMP number library
find_path(GMP_INCLUDE_DIR gmp.h)
find_library(GMP_LIBRARY gmp)
if (GMP_INCLUDE_DIR AND GMP_LIBRARY)
    message(STATUS "GMP headers: " ${GMP_INCLUDE_DIR})
    message(STATUS "GMP library: " ${GMP_LIBRARY})
else()
    MESSAGE(FATAL_ERROR "Could not the GMP number library (sudo apt-get install libgmp-dev)")
endif()


# statistics configuration
if(LIBPOLY_BUILD_STATISTICS)

  add_definitions(-DLIBPOLY_STATISTICS)

endif()

#
# Check for open_memstream
#
include(CheckFunctionExists)

check_function_exists(open_memstream HAVE_OPEN_MEMSTREAM)

if(HAVE_OPEN_MEMSTREAM)
  add_definitions(-DHAVE_OPEN_MEMSTREAM)
endif()

# Configure the library source
add_subdirectory(src)

# Configure the headers
add_subdirectory(include)

if(LIBPOLY_BUILD_PYTHON_API)

  # Need the Python binary to run tests
  find_package(PythonInterp)

  # Configure the Python bindings
  add_subdirectory(python)

  # Configure the Python tests
  add_subdirectory(test/python)

endif()

# Configure the C++ tests
enable_testing()
add_subdirectory(test/polyxx)

=== src/CMakeLists.txt ===
set(poly_SOURCES 
  utils/debug_trace.c
  utils/assignment.c
  utils/statistics.c
  utils/output.c
  utils/sign_condition.c
  number/integer.c
  number/rational.c
  number/dyadic_rational.c
  number/algebraic_number.c
  number/value.c
  interval/interval.c
  interval/arithmetic.c
  variable/variable_db.c
  variable/variable_list.c
  variable/variable_order.c
  upolynomial/umonomial.c
  upolynomial/upolynomial.c
  upolynomial/output.c
  upolynomial/upolynomial_dense.c
  upolynomial/bounds.c
  upolynomial/gcd.c
  upolynomial/factors.c
  upolynomial/factorization.c
  upolynomial/root_finding.c
  polynomial/monomial.c
  polynomial/coefficient.c
  polynomial/output.c
  polynomial/gcd.c
  polynomial/psc.c
  polynomial/factorization.c
  polynomial/polynomial.c
  polynomial/polynomial_context.c
  polynomial/feasibility_set.c
  polynomial/polynomial_hash_set.c
  polynomial/polynomial_vector.c
  poly.c
)

if (NOT HAVE_OPEN_MEMSTREAM) 
  set(poly_SOURCES utils/open_memstream.c ${poly_SOURCES})
endif()

set(polyxx_SOURCES
  polyxx/algebraic_number.cpp
  polyxx/assignment.cpp
  polyxx/context.cpp
  polyxx/dyadic_interval.cpp
  polyxx/dyadic_rational.cpp
  polyxx/integer_ring.cpp
  polyxx/integer.cpp
  polyxx/interval_assignment.cpp
  polyxx/interval.cpp
  polyxx/polynomial.cpp
  polyxx/polynomial_utils.cpp
  polyxx/rational.cpp
  polyxx/rational_interval.cpp
  polyxx/sign_condition.cpp
  polyxx/upolynomial.cpp
  polyxx/utils.cpp
  polyxx/value.cpp
  polyxx/variable.cpp
)

# Add warnings as errors for good practice
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror -Wextra -std=gnu99")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror -Wextra -std=c++11")

include_directories(${GMP_INCLUDE_DIR})
include_directories(${libpoly_SOURCE_DIR}/include)
include_directories(${libpoly_SOURCE_DIR}/src)

add_library(poly SHARED ${poly_SOURCES})

set_target_properties(poly PROPERTIES
  VERSION ${LIBPOLY_VERSION}
  SOVERSION ${LIBPOLY_VERSION_MAJOR}
)

target_link_libraries(poly ${GMP_LIBRARY})

add_library(polyxx SHARED ${polyxx_SOURCES})
set_target_properties(polyxx PROPERTIES
  VERSION ${LIBPOLY_VERSION} 
  SOVERSION ${LIBPOLY_VERSION_MAJOR}
) 

target_link_libraries(polyxx poly ${GMP_LIBRARY})

#
# For windows and friends: the DLL goes into <install>/bin
# and the lib goes into <install>/lib
# cmake complains if the RUNTIME DESTINATION bin is missing
#
if (CYGWIN OR WIN32 OR MINGW)
 install(TARGETS poly LIBRARY DESTINATION lib RUNTIME DESTINATION bin)
 install(TARGETS polyxx LIBRARY DESTINATION lib RUNTIME DESTINATION bin)
else()
 install(TARGETS poly LIBRARY DESTINATION lib)
 install(TARGETS polyxx LIBRARY DESTINATION lib)
endif()

#
# BD: also build the archive libpoly.a
#
if (LIBPOLY_BUILD_STATIC)
  add_library(static_poly STATIC ${poly_SOURCES})
  set_target_properties(static_poly PROPERTIES OUTPUT_NAME poly)
  install(TARGETS static_poly ARCHIVE DESTINATION lib)

  add_library(static_polyxx STATIC ${polyxx_SOURCES})
  set_target_properties(static_polyxx PROPERTIES OUTPUT_NAME polyxx)
  install(TARGETS static_polyxx ARCHIVE DESTINATION lib)
  target_link_libraries(static_polyxx static_poly)
endif()

#
# If libpoly.a is not position independent, we may need
# another version that's build to be position-indenpedent code.
# This allows the library to be embedded into something like libyices.so
#
# Linux, FreeBSD, and old versions of Darwin (and probably other systems) don't use fPIC by default.
# We just check for Linux and FreeBSD here.
# 
if(LIBPOLY_BUILD_STATIC_PIC)
  add_library(static_pic_poly STATIC ${poly_SOURCES})
  set_target_properties(static_pic_poly PROPERTIES OUTPUT_NAME picpoly POSITION_INDEPENDENT_CODE true)
  install(TARGETS static_pic_poly ARCHIVE DESTINATION lib)

  add_library(static_pic_polyxx STATIC ${polyxx_SOURCES})
  set_target_properties(static_pic_polyxx PROPERTIES OUTPUT_NAME picpolyxx POSITION_INDEPENDENT_CODE true)
  install(TARGETS static_pic_polyxx ARCHIVE DESTINATION lib)
  target_link_libraries(static_pic_polyxx static_pic_poly)

# iam: safer to just be uniform?
#  if(NOT (${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD"))
#    set_target_properties(static_pic_poly PROPERTIES EXCLUDE_FROM_ALL ON)
#    set_target_properties(static_pic_polyxx PROPERTIES EXCLUDE_FROM_ALL ON)
#  endif()
endif()

=== debian/changelog ===
libpoly0 (1.8-0ubuntu1) bionic; urgency=medium

  * Initial release. (Closes: #864834)

 -- Ian A. Mason <iam@csl.sri.com>  Thu, 10 Aug 2017 13:46:30 +0000

=== debian/control ===
Source: libpoly0
Section: libs
Priority: optional
Maintainer: Ian A. Mason <iam@csl.sri.com>
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 10), cmake, libgmp-dev, dh-exec
Homepage: https://github.com/SRI-CSL/libpoly

Package: libpoly0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: C library for manipulating multivariate polynomials
 Used by the SMT solver yices2.

Package: libpoly-dev
Section: libdevel
Architecture: any
Depends: libpoly0 (= ${binary:Version}), ${misc:Depends}, libgmp-dev
Description: C library for manipulating multivariate polynomials
 Used by the SMT solver yices2.
 .
 This package contains development headers for libpoly.


Package: libpoly-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: libpoly0 (= ${binary:Version}), ${misc:Depends}
Provides: libpoly-dbg
Description: C library for manipulating multivariate polynomials
 Used by the SMT solver yices2.
 .
 This package contains the debugging symbols for libpoly.
